CHEFCODE - Editorial

Problem Link

Practice

Contest

Author: Prateek

Tester: Pawel Kacprzak and Misha Chorniy

Editorialist: Bhuvnesh Jain

Difficulty

MEDIUM

Prerequisites

Product Trick, Meet-in-Middle

Problem

You are given an array A. You are required to find the number of subsequences of A such that product of the elements of the subsequence is less than or equal to K.

Quick Explanation

Calculate all possible subsets product for 2 halves of the array. Apply meet in the middle to find the overall answer.

Explanation

First of all we count the number of subsequences of any array of size n. For every element there are 2 choices, either consider that element into the subsequence or not. Thus the total number of subsequence is 2^n. This also includes 2 trival case, the empty subsequence where all the elements are considered and the full subsequence, where all the elements are considered.

Subtask 1

This subtask can be easily solved using brute force by iterating over all the subsets and checking whether their product of elements is less than or equal to O(K) or not. This will take complexity O(n * 2^n) which is too slow for larger subtask. Below is the pseudo code for iterating over all subsets and getting the elemnts present in each element.


//Assuming 0-based indexing
n = size(a)
up = 1 << n
for i in 0 to (up-1):
	prod = 1
	for j in 0 to (n-1):
		if (i & (1 << j)):
			//element j is present in given subset/subsequence
			prod *= a[j]
	if (prod <= K):
		ans += 1


Subtask 2

Solution 1

Before reading the solution outlined below, I request you to go throught this editorial on Meet in the middle. After going throught the first example in the above link, we can get some idea, how we are going to approach this question. We simply find the product of all possible subsets after diviing the array into 2 parts. Since each part be of maximum size 15, the above procedure will be feasible. The complexity of this pre-calculation takes O(2 * (n/2) * 2^{n/2}) = O(n * 2^{n/2}), which would easily fit into our time limit. Now, we simply sort the above 2 arrays. Let us call these arrays, B and C. Then, consider all the elemts of B one by one and check how many elements of C can give product less than or equal to K, with the given element. The sum over all the elements is the required answer. For finding the number of elements in C, we can use binary search to find out how many number are less than \frac{K}{B[i]}. This is because we want B[i] * x <= K, i.e. x \leq \frac{K}{B[i]}, where x \in C

Solution 2

This solution is specific for this problem only. Here we will use the fact that product of 20 distinct numbers will always exceed {10}^{18} as the smallest product of 20 distinct numbers is factorial(20) \approx 2.43 * {10}^{18}. So, we simply do a recursive procedure and try to solve the problem. Here at each step of the recursion, we have 2 choices i.e. either to include the object into the subsequence or not. Doing it naively will give the same result as brute force and give time limit exceeded. Also, there are almost no overlapping sub-problems as well, so dynamic programming cannot be applied. So, we basically cut down the recursion depth and make it work almost as fast as the above solution, (sometime even faster than the above solution) using the following tricks :

  1. If the product at any moment of time exceed K, just stop the recursion at that level. Using the above argument, we can see that the maximum depth of any recursive procedure will be 20 only.
  2. Sort the numbers in reverse order and remove the duplicates. As larger numbers will get multiplied in initial stages of recursion, earlier we will get to the product exceeding K and thus greatly reducing the recursion depth.
  3. Maintain prefix product in reverse manner. This will help us to evaluate the answer in O(1) if it is possible at any moment of time and stop the useless recursion as well. This can be done if at any moment of time we know that X * Y <= K, where X = current product and Y = product of remaining numbers to be seen.

The above recursive solution can be found in the Editorialist 2nd solution.

Caveats

All the above algorithms will work correctly, just that there can be issues with overflows, due to the constraints on the numbers in the question. For example, multiplying 2 number as large as {10}^{10} will easily result in overflow in most languages, if not using big integer arithmetic support. The editorialist has used big integer library support in python in order to avoid any issues but the same can be handled in C, C++, Java etc using the below function :

 
INF = 2e18
bool safe_mul(a, b):
	if (a <= (INF+b-1)/b) return true
	return false

Thus the product of 2 numbers should be taken only when it is safe to multiply them else it can be concluded that the product will exceed K (maximum value of K in the problem is given as {10}^{18}).

Time Complexity

O(n * 2^{n/2})

Solution Links

Setter’s solution

Tester’s solution

Editorialist solution - 1

Editorialist solution - 2

10 Likes

I need editorial for GPD, want to know how to solve GPD.

2 Likes

Can anyone tell me what’s wrong with my code?
It’s giving wa in 8th test case…

https://www.codechef.com/viewsolution/13629225

can anyone please tell what is wrong in my code
https://www.codechef.com/viewsolution/13580088
it is giving WA in two test cases

Simple recursion can solve this problem. Reducing array values into Log(Value) will cause the problem to change from Product Subsequence to Sum subsequence to prevent long overflow and reducing heavy multiplication. Counting number of ones and Simple Recursion without ONES with optimized Breaking from recursion does the trick. Final answer can be calculated by using Simple Combination Logics which you can see here Java 0.09s: AC Code Link

5 Likes

It can be also solved with dp approach (with map)


[1]


  [1]: https://www.codechef.com/viewsolution/13443776
1 Like

Can anyone tell me what’s wrong with this solution, CodeChef: Practical coding for everyone .I didn’t get even 30pts for this.I have done the same as the subtask 1 of this editorial.

A simple brute force recursion (along with concept of log and O.C. of ‘trimming’) gave me an A.C :smiley:

My code

2 Likes

I solved the problem with method explained in subtask2 solution1 ie Meet in the Middle . It gave the correct answer only when i sort the input array but i am unable to find out why we need to sort input array ? Can someone please explain this .

Here is my solution

  1. with sorting
    CodeChef: Practical coding for everyone
  2. without sorting
    CodeChef: Practical coding for everyone
2 Likes

Please add the tag “may17” in all the editorials. It will be easier to find all the editorials at once. Also, someone please upvote me so I can gain commenting privileges.

1 Like

@shivank01 as Ai is too large 10^18 and you are taking product of a whole subset eventually you would exceed the limit lets say there are 10 elements of 10^18 s the product would be 10^180 then integer overflow happens you should have just use the condition if your product>=k at any point break else if you move to the end of loop successfully just increase the count, and ans will be count-1,that is don’t count empty subset this will allow you to fetch 30 points only. Hope this helps!

1 Like

can anybody explain how duplicates are handled in 2nd approach ?

@admin I guess there’s a problem .

SHORT-

Same code shows accepted during the contest but now in the practice arena it shows TLE.

LONG-

I submitted my solution during the contest . Got AC answers in subtask #1 (30 points) and in subtask #2 , all tasks were AC except two tasks numbered 1,8. But now when i submit the same solution (code) in the practice arena … mentioned in this post . I get a TLE for each and every task .
Do u consider this as a problem on ur part ?

LINKS-

my solution during contest- CodeChef: Practical coding for everyone

same solution after the contest(in practice arena) - CodeChef: Practical coding for everyone

Got AC by using Log and DP :slight_smile:

code

Pseudo code for Subtask 1 will give you a TLE if you don’t perform a raincheck i.e. a[i]<K.

Why can’t we use dp for this problem?
I have done using dp. Can someone tell me if it is a correct approach?

My code

can anyone tell me what is the wrong with this solution,CodeChef: Practical coding for everyone .i do same as the editorials solution 1.

in the editorial it is said that we can sort the array and remove dublcates…after removing dublicates how will we handle the answer…

I got all testcases accepted in 0.06 sec but got TLE for task 8. Can anyone tell whats wrong with my code? CodeChef: Practical coding for everyone .

I need editorial for long sandwich question please post asap